/*******************************************************************
 *
 *	File:		ArloApp.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2001, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __ARLO_APP_H
#define __ARLO_APP_H

#include <coecntrl.h>
#include <coeccntx.h>
#include <coemain.h>

#include <eikappui.h>
#include <eikapp.h>
#include <eikdoc.h>
#include <eikcmds.hrh>

#include "CArloEngine.h"

#include "Arlo.hrh"


const TUid KUidArloApp = { 0x10009BB6 };


class CWsBitmap;

class CArloDocument : public CEikDocument
{
public:
	~CArloDocument();
	CArloDocument(CEikApplication& aApp);
	void ConstructL();

private: // from CEikDocument
	CEikAppUi* CreateAppUiL();
};


class CArloAppView : public CCoeControl, public MCoeControlBrushContext
{
public:
	~CArloAppView();
	void ConstructL(const TRect& aRect);
private:
	void Draw(const TRect& /*aRect*/) const;

	CWsBitmap*	iBgImage;
	TPoint		iImagePosition;

	CWsBitmap*	iBgImage1;
	TPoint		iImagePosition1;
};



class CArloAppUi : public CEikAppUi
{
public:
	CArloAppUi(){}
	void ConstructL();
	~CArloAppUi();

	TBool IsColorDevice();

		// cannot be called during construction of the document!
	static CArloAppUi*	Static() {return (CArloAppUi*) CEikonEnv::Static()->AppUi();}

protected: // from CEikAppUi
	void DisplayOptionsBootListDialogL();
	void DisplayBootListDialogL();
	void DisplayAboutDialogL();
	void DisplayArloOptionsDialogL();
	void SaveConfigFile();
	void DisplayArloInfoL();
	void HandleCommandL(TInt aCommand);

protected:
	static TInt TimerCallBack(TAny* aAny);
	void StartStartupTimer();
	void StartupTimerFired();
	void CancelStartupTimer();
	CPeriodic*	iPeriodic;
	

protected:
	TInt	iBootTimeout;

	CArloAppView*	iAppView;
	CArloEngine*	iArloEngine;
};






class CArloApplication : public CEikApplication
	{
private: // from CApaApplication
	CApaDocument* CreateDocumentL();
	TUid AppDllUid() const;
	};

#endif
