/*******************************************************************
 *
 *	File:		CArloEngine.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2002, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __C_ARLO_ENGINE__H
#define __C_ARLO_ENGINE__H

#include <e32std.h>

#include "CArlo.h"
#include "RArlo.h"
#include "CArloConfig.h"


class CArloEngine : public CBase
{
public:
	~CArloEngine();
	static CArloEngine*	NewL(RWsSession* aWsSession, RFs* aFs);

	CArloBase&		Arlo() {return *iArlo;}
	CArloConfig&	ArloConfig() {return *iArloConfig;}

	void BootLinuxL(const TArloBootItem& aArloBootItem);
	TBool RunsAsSystemBootLoader() {return iRunsAsSystemBootLoader;}
	void LoadKernelImageL(const TArloBootItem& aArloBootItem);
	void LoadInitrdImageL(const TArloBootItem& aArloBootItem);
	TBool BootLinux(const TArloBootItem& aArloBootItem);
	TBool SaveConfig();
	void SetConfig(CArloConfig* aArloConfig);
	void StartEpoc();
	void StartEpocIfRunningAsBootLoader();

protected:
	CArloEngine(RWsSession* aWsSession, RFs* aFs);
	void ConstructL();
	void ResetArloL();

	void ConfigArlo(const TArloBootItem& aArloBootItem);

	CArloConfig*	iArloConfig;
	CArloBase*		iArlo;
	RArLo			iArloDevice;

	RWsSession*		iWsSession;
	TBool			iOwnsWsSession;

	RFs*			iFs;
	TBool			iOwnsFs;
	TBool			iRunsAsSystemBootLoader;
};



#endif			/ * __C_ARLO_ENGINE__H */

