############################################
#
# Release script for arlo
#
#############################################

$boot2nd_dir = "\\\\gandalf\\public\\spare\\DemonHomePage\\boot2nd\\latest";


############################################
#
# Prerequisites
#
#############################################

print "Have you built and released boot2nd? (y/n)\n";
chop ($question = <STDIN>);
($question eq "y") or die "\nBuild boot2nd first\n";
print "Have you updated the version number and the readme? (y/n)\n";
chop ($question = <STDIN>);
($question eq "y") or die "\nWhat were you thinking! ;-)\n";
print "Have you disabled debug logging? (y/n)\n";
chop ($question = <STDIN>);
($question eq "y") or die "\nWhat were you thinking! ;-)\n";


############################################
#
# Build all components for target
#
#############################################

chdir "\\arlo\\app\\group";
system "nmake -f arloapp.marm clean";
chdir "\\arlo\\app\\group\\aif";
system "build all";
chdir "\\arlo\\app\\group";
system "bitmap";
system "nmake -f arloapp.marm";

chdir "\\arlo\\exe";
system "nmake -f arlo.marm clean";
system "nmake -f arlo.marm";

chdir "\\arlo\\ldd";
system "nmake -f \\arlo\\ldd\\arlo.marm clean";
system "nmake -f \\arlo\\ldd\\arlo.marm";

chdir "\\arlo\\shell";
system "nmake -f \\arlo\\shell\\arloshell.marm clean";
system "nmake -f \\arlo\\shell\\arloshell.marm";


############################################
#
# Build a release directory
#
#############################################

@arlo_apps_file_list = (
					"\\epoc32\\release\\marm\\rel\\arlo.app", 
					"\\epoc32\\release\\marm\\rel\\arlo.rsc",
					"\\epoc32\\release\\marm\\rel\\arlo.mbm",
					"\\epoc32\\release\\marm\\rel\\arlo.aif"
				);

@arlo_libs_file_list = (
					"\\epoc32\\release\\marm\\rel\\arlo.ldd"
				);

@arlo_file_list = (
					"\\arlo\\readme.html",
					"\\arlo\\example.cfg",
					"\\arlo\\copying",
					"\\arlo\\boot2nd\\boot2nd.bin",
					"\\epoc32\\release\\marm\\rel\\arlo.exe",
					"\\epoc32\\release\\marm\\rel\\arlosh.exe"
				);

@src_file_list = (
					"\\arlo\\*.*",
					"\\arlo\\app\\src\\*.cpp",
					"\\arlo\\app\\src\\*.h",
					"\\arlo\\app\\group\\*.mmp",
					"\\arlo\\app\\group\\*.bmp",
					"\\arlo\\app\\group\\*.hrh",
					"\\arlo\\app\\group\\*.rss",
					"\\arlo\\app\\group\\*.cnd",
					"\\arlo\\app\\group\\aif\\*.bmp",
					"\\arlo\\app\\group\\aif\\*.cmd",
					"\\arlo\\app\\group\\aif\\*.rss",
					"\\arlo\\app\\group\\aif\\*.lst",
					"\\arlo\\exe\\*.cpp",
					"\\arlo\\exe\\*.h",
					"\\arlo\\exe\\*.mmp",
					"\\arlo\\common\\*.cpp",
					"\\arlo\\common\\*.h",
					"\\arlo\\boot2nd\\*.h",
					"\\arlo\\ldd\\*.cpp",
					"\\arlo\\ldd\\*.h",
					"\\arlo\\ldd\\*.mmp",
					"\\arlo\\shell\\*.cpp",
					"\\arlo\\shell\\*.h",
					"\\arlo\\shell\\*.mmp",
					"$boot2nd_dir\\boot2nd.tgz",
				);

#
# Clean up first
#
chdir "\\arlo";
system "rd /s/q reldir";
system "md reldir";


#
# copy all files for \system\apps\arlo
#
foreach $file (@arlo_apps_file_list) 
{
	(-e $file) or die "$file does not exist";
	system "xcopy $file reldir\\system\\apps\\arlo\\";
}

#
# copy all files for \system\libs
#
foreach $file (@arlo_libs_file_list) 
{
	(-e $file) or die "$file does not exist";
	system "xcopy $file reldir\\system\\libs\\";
}


#
# copy all files for \arlo
#
foreach $file (@arlo_file_list) 
{
	(-e $file) or die "$file does not exist";
	system "xcopy $file reldir\\arlo\\";
}




#
# Concatenate all file parameters for src.zip
#
foreach $file (@src_file_list) 
{
	$src_param .= $file . " ";
}

#
# Create the bin zip file
#
unlink "\\arlo.zip";
#print "bin: $bin_param\n";
chdir "\\arlo\\reldir";
system "\\arlo\\wzzip \\arlo.zip -rP *";

#
# Create the src zip file
#
chdir "\\arlo";
unlink "\\arlosrc.zip";
#print "src: $src_param\n";
system "wzzip \\arlosrc.zip -P $src_param -x\\arlo\\wzzip.exe";
